#include "xpm.h"
#include <X11/Intrinsic.h>
#include <X11/Xlib.h>
#include <stdlib.h>
#include <iostream.h>

XEvent event;
Display *disp;
Window win, root;
unsigned long gc_mask;
XGCValues gc_values;
GC gc1, gc2, gc3, gc4;
XColor screen_ret, exact_ret;
XImage *xi;

XpmAttributes attr;
char *data;

int main( int argc, char **argv)
{
  disp = XOpenDisplay( NULL );
  if( argc!=2) {
	cout << " Usage: grabber <name-of-file-to-save>\n";
	exit(0);
  }
  
  if( !disp ) exit(0);
  cout << "waiting ... ";
  root = DefaultRootWindow( disp );

  int n;
  Position x,y,nux,nuy;
  Position oldx, oldy;
  Boolean to_draw = False;
  
  gc_mask = GCFunction | GCForeground | GCBackground | GCSubwindowMode;
  gc_values.function = GXxor;
  gc_values.foreground = 1;
  gc_values.background = 0;
  gc_values.subwindow_mode  = IncludeInferiors;
  gc1 = XCreateGC( disp, root, gc_mask, &gc_values );
  
  n= XGrabPointer( disp, root, False, Button1MotionMask | ButtonPressMask |
				  PointerMotionMask | ButtonReleaseMask, GrabModeAsync,
				  GrabModeAsync, root, None, CurrentTime );
  if( n==GrabSuccess ) {
	cout << "waiting for events\n";
	while(1) {
	  XNextEvent( disp, &event );
	  switch ( event.type ) {
	  case ButtonPress:
		
		x = ((XButtonEvent *)&event)->x_root;
		y = ((XButtonEvent *)&event)->y_root;
		oldx = x;
		oldy = y;
		XDrawRectangle( disp, root, gc1, oldx, oldy, x-oldx, y-oldy );
		to_draw = True;
		
		break;
	  case MotionNotify:
		if( to_draw ) {
		  XDrawRectangle( disp, root, gc1, oldx, oldy, x-oldx, y-oldy );
		  x = ((XButtonEvent *)&event)->x_root;
		  y = ((XButtonEvent *)&event)->y_root;
		  XDrawRectangle( disp, root, gc1, oldx, oldy, x-oldx, y-oldy );
		  cout << x-oldx << " - " << y-oldy << endl; 
		}
		break;
	  case ButtonRelease:
		XDrawRectangle( disp, root, gc1, oldx, oldy, x-oldx, y-oldy );
		nux = ((XButtonEvent *)&event)->x_root;
		nuy = ((XButtonEvent *)&event)->y_root;

		Dimension wid, hei;
		wid = nux - oldx;
		hei = nuy - oldy;
		xi = XGetImage( disp, root, oldx,oldy,wid,hei,255,ZPixmap );

		if( xi==NULL ) { cout << "could get IMAGE\n"; exit(0); } else {
		  cout << "got image\n"; }
		
/*		attr.depth = xi->depth;
		attr.width = 10 ; //(unsigned int) xi->width;
		attr.height = 10 ; // (unsigned int) xi->height ;
		attr.visual = DefaultVisual( disp, 0);
		attr.colormap = DefaultColormap( disp, 0);

		attr.valuemask = XpmVisual |
		   XpmColormap |
		   XpmDepth |

		   XpmSize ;  */

		attr.colormap = DefaultColormap( disp, 0);
		
		attr.valuemask = XpmColormap;
		
		int i;
		i = XpmWriteFileFromImage( disp, argv[1], xi, NULL, &attr );
		
		switch( i ) {
		case XpmSuccess:
		  cout << "DONE\n";
		  exit(0);
		  break;
		case XpmOpenFailed:
		  cout << "open failed\n";
		  break;
		case XpmColorError:
		  cout << "color error\n";
		  break;
		case XpmFileInvalid:
		  cout << "file invalid\n";
		  break;
		case XpmColorFailed:
		  cout << "color failed \n";
		  break;
		}
		break;
	  }
	}
  }
  switch(n) {
  case GrabSuccess:
	cout << "grab success\n";
	break;
  case GrabNotViewable:
	cout << "now viewable\n";
	break;
  case GrabFrozen:
	cout << "frozen\n";
	break;
  case AlreadyGrabbed:
	cout << "already grabbed\n";
	break;
  }
  
  
}

	  

